import Flutter
import UIKit
import Toast_Swift

public class SwiftFlutterNativeToastPlugin: NSObject, FlutterPlugin {
    
    var isInited = false
    
    
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_native_toast", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterNativeToastPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }
    
//    public override init() {
//        super.init()
//        self.startHost()
//    }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
//    result("iOS " + UIDevice.current.systemVersion)
    switch call.method {
    case "showToast":
        showToast(call: call, result: result)
    case "hideToast":
        UIApplication.shared.keyWindow?.hideAllToasts()
    default:
        result(FlutterMethodNotImplemented)
    }
  }
  func showToast(call:FlutterMethodCall,result:FlutterResult) {
        
        let args = call.arguments as! [String:Any]
        let positon = convertInt(value: args["position"] as! Int)
        let msg = args["msg"] as! String
        UIApplication.shared.keyWindow?.hideAllToasts()
        UIApplication.shared.keyWindow?.makeToast(msg,position: positon)
        
        
        
    }
    //int to enum
  func convertInt(value:Int) -> ToastPosition{
        switch value {
        case 0:
            return ToastPosition.top
        case 1:
            return ToastPosition.center
        case 2:
            return ToastPosition.bottom
        default:
            return ToastPosition.top
        }
  }
//    deinit {
//        stopNotifier()
//    }

}

//extension SwiftFlutterNativeToastPlugin {
//
//
//
//    func startHost() {
//        stopNotifier()
//        setupReachability()
//        startNotifier()
//    }
//
//    func setupReachability() {
//        let reachability: Reachability?
//        reachability = try? Reachability.init(hostname: "www.baidu.com")
//        self.reachability = reachability
//
//        NotificationCenter.default.addObserver(
//            self,
//            selector: #selector(reachabilityChanged(_:)),
//            name: .reachabilityChanged,
//            object: reachability
//        )
//    }
//
//    func startNotifier() {
//        print("开始监听")
//        do {
//            try reachability?.startNotifier()
//        } catch {
//            print("监听失败")
//            return
//        }
//    }
//
//    func stopNotifier() {
//        print("停止监听")
//        reachability?.stopNotifier()
//        NotificationCenter.default.removeObserver(self, name: .reachabilityChanged, object: nil)
//        reachability = nil
//    }
//
//
//    @objc func reachabilityChanged(_ note: Notification) {
//        let window = UIApplication.shared.keyWindow;
//        let reachability = note.object as! Reachability
//        //启动时不提示
//        if(isInited == false){
//            isInited = true
//            return
//        }
//        switch reachability.connection {
//        case .unavailable:
//            print("网络无连接")
//            //                window?.makeToast("网络无连接")
//            window?.makeToast("网络无连接,请检查您的网络", duration: 2.0,title: "",  image: UIImage(named: "home_invite_icon")) { didTap in
//                if didTap {
//                    print("completion from tap")
//                } else {
//                    print("completion without tap")
//                }
//            }
//        case .cellular:
//            print("数据连接")
//            window?.makeToast("数据连接")
//        case .wifi:
//            print("WiFi连接")
//            window?.makeToast("WiFi连接")
//
//        case .none:
//            print("网络无连接.")
//        }
//    }
    
    
//}
